;wifi stahovatko, MB03
;Hood
;ver0.40- release version
;ver0.34- rewritting speed management, previous was too complicated and worked not good
;ver0.33- adding speed management- done
;	- even for core with all speeds, the speed is limited to 1152000 Baud (rece_blok cannot do more than 2kb buffer without loss of data) and the http requests are still for 32 kb of data- done
;	- added- if border turns magenta, TX line is busy	
;	- PRINT routine corrected
;ver0.32- shortening of http request sending procedure- done
;	- adding upload- written, not tested, php not exist
;	- bios 1.4 added
;ver0.31- adding upload...
;- adding speed 1152000
;- improving raw data processing, improves speed- done. (Busy's idea not done yet).
;- sending http requests for 32kb block, previously was only 2kb- done
;- bios 1.3 added


;ver0.30=release
;ver0.25
;- PRINT- change to rewrite chars-> clean_line left out!!!*done, time enhanced from 2:08 to 2:03
;- DMA added-*done
;- PRINT turnoff option-*done
;- new bios added- *done
;ver0.24
;- code optimisation: CLOSED not seeked any more-done
;- SP from under #63E0 to end of app- done but data flow too fast and are loosing
;ver0.23
;- code optimisation (Basic+ this application) to extend disk buffer as much as possible
;- code in lower memory (under #8000) working too slow. It must be: BASIC, disk buffer,free,app code,bios.
;ver0.22
;- new: increasing disk buffer to increase download speed, increased to #8000
;- new: adding path
;ver0.21
;XOR checksum added for 100% data transfer reliability
;ver0.2
;bugfix:
;- "look for string" routine- timeout was not running*done
;- send command: some more timeout added*done (error BC=6 should be fixed, now)
;- if data contained part of IPD string (same as "ipd" label see below), data were cleaned badly*done
;- 32 bit length added- *done
;- download speed improvement- *done, speed= cca 3,2 KB/sec including disk save. The speed is 4,2 KB/sec without disk save*done.(1,99 MB file transfered in 19 minutes and 45 secs= 1,68 KB/sec).
;- new: press& hold space to cancel download*done
;- new: file size& progress display*done
;- new: if info.php returns NE (File not Exist), dsiplay it*done, in BASIC error nr.19
;- new: test if server supports PHP*done

	output "wifi_app"

;set C=		SCF
;set NC=	AND A, if Z needs to be preserved, then SCF:CCF

;overview:
;SENDING
;1) send_string:	mainly to send direct AT commands
;2) send_data:		to send any type of data


;RECEIVING
;6) receive_data	receive data
;7) receive_data_timeout receive data with timeout

;PARSING
;10) look_for_string:	seeks certain string in memory
;11) look_on_fly:	seeks certain string in the incoming flow of bytes


;OTHER
;15) count_com_len	counts command length before sending (for CIPSEND mode)
;16) ConvRStr16		unused, converts ASCII to HL (16 bit)
;17) HL2ASCII		converts HL to ASCII (16 bit)
;18) wait routines	wait certain amount of time (user definable)
;19) prepare_php_com	prepare php command to RX_buf (not a complete http request)
;20) move_gap		moves gap in received data, UNUSED
;21) cls		clear screen
;22) ConvRStr32		converts ASCII (32 bit) to DEHL by Busy
;23) clean_line		unused, cleans 5 characters for progress display purposes
;24) insert_path	inserts path if any to http request
;25) count_end_data_add	used in "move_gap",counts end data adress of block sent by module
;26) ldir_dma		form Shrek's MBC
;27) complete send	4 routines to prepare& send command/ request
;28) HL2ASCII32		converts HL to ASCII (32 bit)
;29) send_at_check_ok	sends AT command and checks for answer OK
;40) set_print_speed	sets speed and print it

;HTTP REQUESTS
;30) test.php
;31) info.php
;32) download.php
;33) upload.php


;	DEFINE border_colour	;0=no colours,1=show border colours, yellow for disk operations,
				;violet= communication with module
	
buf_len		equ #8000	;nemelo by byt pevne, ale PHP script to ma tez pevne dano
;buf_len	equ #800
main_port	equ #203B
wifi_port	equ #213b
basic_end	equ #63E0
speed_pos	equ #4900



bios		equ	#FE00
gver_inst	equ	bios+0
wifi_on		equ	bios+4
wifi_off	equ	bios+6
set_baud	equ	bios+8
clear_rece_buf	equ	bios+12
rece_byte	equ	bios+16
send_byte	equ	bios+18
rece_block	equ	bios+20




;BASIC programs calls the code with various parameters embeded in RANDOMIZE:
;address 23670 (has to be different from 0), so bit 0 is automatically set to 1
;RANDOMIZE.....b0=1, b1=0=download, 1=test PHP server, b2=0=data parity check on, 1=off

;presunout vykonny program do zvlastniho souboru

		org #E600
;		org bios-len			;

start

		jp	start_here

name_php	db "wifi_app",0			;variable file name
		ds 31				;reserve for name
host_url	db "192.168.0.103",0		;length=variable, url 
;host_url	db "test.ilnx.cz",0		;length=variable, url 
		ds 32				;reserve for url
path		db 0				;some variable definitions are here for POKEing from BASIC
		ds 63
id		db	"ver0.40",0
upl_f_num	dw #5555			;file number to upload, POKEd by BASIC


start_here	di
		ld	(stack_pointer+1),sp
		ld	sp,0			;fast but have to be combined with good timeout value
;		ld	sp,end-4		;prilis rychle, nenacte cela data do konce!!!!

		ld	a,(23670)
		rra
		rra
		ld	ix,flag1
		res	4,(ix+0)
		jr	nc,st1			;0=normal start,1=test server for PHP
		set	4,(ix+0)
		
			
st1		ld	hl,#4000
		ld	(HLKO+1),hl		;set print position always
						;flag1 (IX+0),bit 7=used in "HL2ASCII"
						;bit 0=used in "look_for_string"
						;bit 1=SSL/TCP connection toggle,0=TCP,1=SSL
						;bit 2=request type,0=normal,1=download
						;bit 3=dma_ldir,0=no,1=yes
						;bit 4=test PHP server only (1=test, 0=no test&download)
						;bit 5=carry out parity check 1=YES, 0=NO
						;bit 6=disk buffer full?, 1=YES, 0=NO
						;flag2 (IX+3). 	bit 0=print sent command,0=NO, 1=YES
						;bit 1=upload, 0=NO, 1=YES
						;bit 2=load part, 0=continue, 1= last file part loaded
						;bit 4=uart speed, 0=max speed 1152000 or 115200, 1=max speed
						;3456000
		rra
		set	5,(ix+0)
		jr	nc,st2			;Z=parity check is ON
		res	5,(ix+0)

st2		ld	(ix+1),l		;reset parity error counter
		

		ld	hl,speed_pos		;print "Speed" text
		ld	(HLKO+1),hl
		ld	de,speed
		call	PRINT
		ld	hl,#4000
		ld	(HLKO+1),hl





;speed management starts here
;the principle: find out max speed according to FW, then turn on wifi. Find out if UART+Wifi ;communicate, if timeout exceeded, then error. Otherwise establish connection betwee uart and wifi at any speed. ;Then set optimal speed for the FW.

		call	gver_inst		;best bios speeds are: 0=115200, 12=1152000 and
		ex	de,hl			;16=3456000
		ld	de,core			;find out core version
		push	de
		ld	bc,3
		ldir
		pop	hl

		ld	d,0			;now set speed and retry answer from AT command
		ld	a,(hl)			;HL=core version found
		cp	20
		jr	c,got_max_speed		;found core <2019xxxxx,core0
		jr	z,sc1
		ld	d,16
		jr	nc,got_max_speed	;NC=found core>2020=contains high speeds (core2)
sc1		inc	hl
		ld	a,(hl)
		cp	5
		jr	c,got_max_speed		;found core 202004xx,core0, max speed 115200
		ld	d,12
		jr	z,got_max_speed		;Z=found core 202005xx, core1, max speed 1152000

		bit	4,(ix+3)
		jr	z,sc2
		ld	d,16
sc2		cp	6			;test speeds max to 12
		jr	nc,got_max_speed	;found core >202006xx, core2,max speed 3456000
		ld	d,0			;speed not found in FW, set it to 0 (115200)

got_max_speed	ld	(ix+8),d		;d=0 or 12 or 16

		ld	(ix+6),#90		;timeout for more routines below. #90 should be enough.
		res	4,(ix+3)		;limit max speed to 1152000 (ver 0.34 cannot transfer at higher 							;speed)
		ld	(ix+5),0		;starting speed in bios HW is 0	(115200 B)

		call	wifi_on
;		call	wait_short

;		and	a			;not needed at the moment, just in case we want
;		call	set_baud		;to set original speed
;		ld	(ix+7),d		;d=speed set currently in HW


		call	send_at_check_ok
		jr	z,correct_speed
speed_loop	call	clear_rece_buf		;good if wifi turned on from BASIC
		call	switch_speed		;answer not found, we should change speeds and retest
		jr	z,correct_speed		;Z=UART+wifi communicate
		dec	(ix+6)
		ld	bc,29
		jp	z,error			;timeout run out, error
		jr	speed_loop			
						;tady odlisit, zd auz byla wifi zapnuta, nebo ne


correct_speed	and	a			;answer found, uart& module communicate
		call	set_baud		;is it the best speed we want?
		ld	a,(ix+8)
		cp	d
		jp	z,wifi_cont		;Z speed found, we want 0 or 12 for ver 034
						;NZ not the one we want, so set it in, correct in A

;core=0-7, core1=0-12, core2=23 (limited to 12 in ver 034)
set_best_speed					;d=speed set currently in HW, a=speed we want

		ld	de,TX_buf		;now prepare AT comand to TX_buf
		push	de
		ld	hl,uart
		ld	bc,12
		ldir
		ld	c,6
		ld	hl,_1152000
		or	a
		jr	z,sbs4
		inc	c
		cp	12
		jr	z,sbs4
		bit	4,(ix+3)
		jr	z,sbs4			;speed limited to 12
		ld	hl,_3456000
sbs4		ldir
		ld	hl,_8100
		ld	bc,10
		ldir		
		ex	de,hl
		ld	(hl),0

		pop	hl
;		ld	bc,31
		push	af
;		call	send_data		;set speed on the module via AT+UART+CUR command
		call	send_string
		ld	bc,27
		jp	nz,error	

		pop	af
		or	a
		ld	d,7
		jr	z,sbs1
		ld	d,12
		cp	d
		jr	z,sbs1
		bit	4,(ix+3)
		jr	z,sbs1			;limit max speed to 12
		ld	d,16
		cp	d
		jp	nz,error
		scf
sbs1		ld	a,d
		call	set_print_speed		;set also uart speed

;		ld	b,3
;		call	wait_long_def		;b=3 is ok, 2=not ok (kratit bez ld b,3)

sbs2		call	clear_rece_buf		;timeout would be much better?
		call	send_at_check_ok
		jr	z,wifi_cont
		dec	(ix+6)
		jr	nz,sbs2

		ld	de,wifi_no_success
		call	PRINT
		ld	bc,30
		jp	error		

switch_speed	xor	a			;try out every speed if you find connection UART+Wifi
;		scf				;start with lowest speed, end with 23 (not 7, 12 or 23)
sws2		push	af			;natvrdo zkousim 23 rychlosti, melo by to byt dle fw v MBcku
;		call	set_baud
		call	set_print_speed
;		call	wait_short		;when not here, it speeds up conenction process significantly
		call	send_at_check_ok
		pop	de
		ret	z			;Z=answer found, D= speed set in HW
		ld	a,d
		inc	a
		cp	24
		jr	c,sws2
		inc	a			;NZ
		ret

;		pop	de
;		ret	z			;Z=answer found, D= speed set in HW
;		ld	a,(ix+8)		;a=0 or 12 or 16. 0=7, 12=12, 16=23
;		or	a
;		ld	e,7
;		jr	z,sws1
;		ld	e,23
;		cp	16
;		jr	z,sws1
;
;sws1		ld	a,e
;		inc	d
;		cp	a
;		ret	nz			;all speeds tested. Connection UART+Wifi not found.
;		ld	a,d
;		jr	sws2		
;end of speed management here




wifi_cont	ld	de,ok
		call	PRINT
		and	a
		call	print_speed		;prints speeds 7, 12 or 16 (disabled in ver. 0.33)

		ld	hl,ate0
		call	send_string
		ld	hl,ok
		call	look_on_fly
		;test for answer should be here?



;		ld	b,9			;wait 9 experimentally tested, is ok
;w_cont1	call	wait_long_def		;timeout would be much better?



w_cont1		call	clear_rece_buf
		ld	hl,cipstatus		;find out, if module connected to wifi
		call	send_string
		ld	bc,1
		jp	nz,error

		ld	hl,RX_buf		;receive the answer about STATUS to RX_buf
		ld	bc,20
;		ld	bc,30
		push	hl
		push	bc
		call	receive_data_timeout

		pop	bc
		pop	hl
		ld	de,STATUS
		call	look_for_string
		ld	h,d
		ld	l,e
		ld	de,answ_5
		call	look_for_string
		jr	nz,w_cont2		;NZ=status "5" not found, wifi is connected to AP
		dec	(ix+6)
		jr	nz,w_cont1
		jr	w_cont3

w_cont2		push	af		
		call	clear_rece_buf
		ld	de,wifi
		call	PRINT
		pop	af
		jr	nz,jr1

w_cont3		ld	de,not_txt
		call	PRINT
		ld	de,connected
		call	PRINT
		ld	de,to_AP
		call	PRINT
		jp	error

jr1		ld	de,connected
		call	PRINT
		ld	de,to_AP
		call	PRINT

;		bit	7,(ix+0)		;seems, server needs a bit of rest before downloading
;		jr	z,main			;Z=Wifi already was ON, make no pause
;		call	wait_short		;do not like it, but test if server needs a little rest



main		ld	hl,start		;0.22,count buffer length. Flexible
		ld	de,basic_end
		or	a
		sbc	hl,de
		ld	a,h
		and	%11111000		;to obtain *2048
		ld	h,a
		ld	l,0			;HL=maximum length of disk buffer
		ld	(disk_buf_len),hl	;DE=disk buffer start, "end"

		bit	1,(ix+3)
;		jp	nz,upload

		bit	4,(ix+0)
		jp	nz,t_phpp	
		jp	info_phpp






;send comand (http request)
;variables:	- parameter between "GET /" and "HTTP/1.1" (get_param)
;		- URL in "Host: " parameter (host_url)
;so the request has to be build and counted, will be placed in TX_buf

;30)
t_phpp		ld	hl,t_php		;send "t.php" request
		call	prepare_php_com
		res	2,(ix+0)
		
		call	complete_send
;		call	send_execute_command	;result in RX buffer

		ld	bc,20			;now check, if php returns "PHP OK"
		ld	de,php_ok
		ld	hl,RX_buf
		call	look_for_string
		ld	bc,20
		jp	nz,error			;Z=PHP OK not found, server does not support PHP
		xor	a
		ld	(de),a
		push	hl
		pop	de
		ld	hl,#4800		;line 9 from screen top
		ld	(HLKO+1),hl		;set print position always
		call	PRINT
		jp	allok

;here you continue with sending other commands+program, etc....

;ZX si nejprve zavol "info.php", ten vrt dlku celho souboru:
;"http://test.ilnx.cz/info.php?f=img.scr" (vrac: "SZ: 6912")
;pak si ZX zavol jednotliv sti souboru (bloky), jsou dlouh 2048 B. V ppad SCR jsou to 4 bloky:
;0,1,2= o dlce 2048 B, 3= 768 B
;"http://test.ilnx.cz/download.php?f=img.scr&p=0" (cislo bloku)
;Pokud neexistuje, vrt dva bajty s "NE" (NotExist), nebo pokud se d st vt ne dlka souboru, vrt jen dva bajty s "ER". Funguje i na PC v prohlei.

;jak vraci data:v hlavicce:
;"+IPD,1460:"-zacatek hlavicky
; dale je v hlavicce COntent length= cista delka vracenych dat
;za hlavickou je 2x #D,#A a zacinaji data.
;data mohou byt prerusena dalsim "+IPD,846:"
;konec dat a pak hned je CLOSED,#D,#A



;31)
info_phpp	ld	hl,info_php
;		push	hl
		call	prepare_php_com
		call	insert_path
		xor	a
		ld	(de),a			;"info.php?f=/..path if any../img.scr" prepared in RX_buf
		res	2,(ix+0)

		call	complete_send
;		call	send_execute_command	;result in RX buffer

		ld	bc,20			;now check, if php returns "NE"
		ld	de,ne
		ld	hl,RX_buf
		push	hl
		call	look_for_string
		ld	bc,19
		pop	hl
		jp	z,error			;php returned "NE"= not exist


;		ld	hl,RX_buf		;now look for file length
		ld	de,sz
		ld	bc,#16
		call	look_for_string
		ld	bc,14
		jp	nz,error		;NZ=not found
		push	de
		ld	b,d
		ld	c,e
		call	ConvRStr32		;BC=start of ASCII number
		ld	(flen),de		;DEHL=file length
		ld	(blen),de		;vyresit 4 bajtovou delku!!!
		ld	(blen+2),hl
		xor	a
		ld	(bc),a
		ld	b,d
		ld	c,e

		pop	de			;DE=ASCII number in memory

		push	bc			;file length
		push	hl

		push	de

		call	PRINT			;print file length

		ld	de,file_size		;print filesize on screen too
		ld	hl,#4800		;outside of cls
		ld	(HLKO+1),hl
		call	PRINT
		pop	de			;DE=ASCII number in memory
		call	PRINT
		ld	hl,(HLKO+1)
		inc	hl			;4x space
		inc	hl
		inc	hl
		inc	hl
		ld	(HLKO+1),hl

		pop	de
		pop	hl			;DEHL=file length

		exx				;convert DEHL to ???? musim zjistit v Realspecu.....
		ld	de,0
		ld	(current_block),de
sub32_lower	exx
sub32_higher	ld	bc,buf_len
		ld	a,sub32
		call	bsdos
		exx
		inc	de
		jr	z,sub32_2		;Z=if length= whole of buffer
		jr	nc,sub32_lower
		jr	c,sub32_1

sub32_2		exx				;if len is equal add buf_len
		ld	a,d
		or	e
		jr	nz,sub32_higher
		jr	sub32_f

sub32_1		exx
		inc	de			;BSDOS service return #FFFF in DE if C
		ld	a,d
		or	e
		dec	de
		jr	nz,sub32_higher
		
sub32_f		exx
		dec	de
		ld	(file_blocks),de	;HL=total number of file blocks
		push	de
		exx


		pop	hl			;print it
		inc	hl			;including block 0
		ld	de,TX_buf
		push	de
		call	HL2ASCII
		xor	a
		ld	(de),a
		pop	de
		call	PRINT
		ld	a,"/"
		ld	hl,(HLKO+1)
		call	CHAR
;		inc	hl
		ld	a,l
		rra
		jr	nc,c1
		inc	l			;we want even position
c1		ld	(block_asci+2),hl
		ld	hl,#4000
		ld	(HLKO+1),hl		;posun o znak vpravo? Bude to fungovat?
		inc	de
		ld	(block_asci),de		;adresa znaku


;prepare download command to RX_buf
;32)
		ld	hl,basic_end
		ld	(disk_buf_adr+1),hl


						;zde rozhodnout, zda to bude obycejny ldir, nebo DMA ldir

;		ld	hl,shrink_ldir		;decide if move_gap will ldir or ldir_dma
		nop
		nop
		nop
		ld	de,#B000
		ld	a,#ED
		bit	3,(ix+0)
		jr	z,no_ldir_dma
		ld	de,ldir_dma
		ld	a,#CD			;POKE "ldir" or "call ldir_dma" to move_gap
no_ldir_dma	ld	(hl),a
		inc	hl
		ld	(hl),e
		inc	hl
		ld	(hl),d


		ld	hl,exp_name		;prepare file name, nice& clean
		push	hl
		ld 	de,exp_name+1
		ld	bc,9
		ld	(hl),#20
		ldir
		ld	hl,name_php
		push	hl
		call	count_com_len
		pop	hl
		pop	de
		ld	b,0
		ld	c,a
		cp	#B			;test name length
		jr	c,len10
		ld	c,#A
len10		ldir
						;now, prepare the whole php command. Then in each request only
						;block number will be refreshed
		ld	hl,downl_php
		call	prepare_php_com
		call	insert_path

		ex	de,hl			;add "&p="
		ld	(hl),"&"
		inc	hl
		ld	(hl),"p"
		inc	hl
		ld	(hl),"="
		inc	hl
;		ld	(block_nr+1),hl

		ld	b,5
set_00s		ld	(hl),"0"
		inc	hl
		djnz	set_00s
		ld	(hl),b

;		ex	de,hl
	

;		inc	de
;		inc	de
;		inc	de
;		inc	de
;		inc	de

;		ld	hl,(current_block)	;now append block number in ASCII
;		set	7,(ix+0)
;		call	HL2ASCII_00000

;		xor	a
;		ld	(de),a			;php command prepared in RX_buf
						;looks like: "download_sar.php?f=...path...&p=00000"
		call	make_http_request	;create complete http_request to TX_buf
		ld	bc,300			;find addres of block number in the request
		ld	de,apeq
		ld	hl,TX_buf
		call	look_for_string
		ld	(block_nr+1),de		
		call	make_cipstart		;create at connection command to RX_buf

		push	ix
		call	save_file_head		;save file header to disk (open file)
		pop	ix


;ver0.22-new style for download. Data blocks (now 2048 bytes) are read into disk buffer situated after the application and saved only when the buffer is full. The loop starts here.

;here comes the loop to download& save a file cut into 2048 B blocks
dwnld_cycle	call	clear_rece_buf
		ld	hl,#4000
		ld	(HLKO+1),hl		;set print position always
;		call	cls		;not needed anymore, PRINT routine rewritten


		ld	a,#7F		;; Test SPACE key (as break)
		in	a,(#FE)
		and	#01
		ld	bc,16
		jp	z,error		;; Status: A=0 ... BREAK pressed by user

		ld	a,#DF		;; Test P key, to toggle PRINT
		in	a,(#FE)
		and	#01
		ld	hl,flag2
		jr	nz,check_print	;; Status: A=0 ... P pressed by user
		ld	a,(hl)
		xor	1		;toggle
		ld	(hl),a

check_print	bit	0,(hl)
		ld	hl,#54E5	;"push hl:ld d,h"
		jr	nz,printyesno
		call	cls
		ld	hl,#0518	;"jr ss2"
printyesno	ld	(send_string),hl

block_nr	ld	de,#5555
		ld	hl,(current_block)	;refresh& append block number in ASCII
		set	7,(ix+0)
		call	HL2ASCII_00000

	IFDEF border_colourx
		ld	a,3
		out	(254),a
	ENDIF

		set	2,(ix+0)
		call	cipstart_connect
		call	cipsend_request		;send it
						;RX_buf=length of data in ASCII
						;HL=length of data
						;now you finished somewhere in haflway of
						;the header
						;so now let's look directly for data, that
						;come right after header after 2x #D,#A
						;in "data_len" we have still length of
						;incoming netto data

		ld	hl,_2xEOL
		call	look_on_fly
		ld	bc,12
		jp	nz,error
		

						;now, read the raw data into data buffer
		ld	bc,buf_len+512		;have some reserve, hope it is enough
disk_buf_adr	ld	hl,#5555		;start with "basic_end" as disk buffer start
		ld	(data_clean1+1),hl
		ld	(data_clean2+1),hl
		ld	(xor_checksum1+1),hl
		ld	(xor_checksum2+1),hl					
;		push	hl
;		push	bc
;		call	receive_data_timeout

		exx
		ld	hl,0			;HL=number of retries
		exx
rece_loop	ld	de,1			;DE=timeout
		call	rece_block		;direct bios call		
		
		push	bc
		push	hl

		ld	bc,8
		or	a
		sbc	hl,bc			;HL= should be CLOSED
		ld	de,closed
		call	look_for_string
		pop	hl
		pop	bc
		jr	z,shrink_data
		exx
		dec	hl
		ld	a,h
		or	l
		exx
		jr	nz,rece_loop
		ld	bc,24
		jp	error

	IFDEF border_colour
		xor	a
		out	(254),a
	ENDIF

;old way of ldiring raw data several times, too slow
;new concept: with high speed, let the http request sent 32Kb block, with "rece_byte", raw data, with
;metadata (IPDs). Then go from IPD to IPD and ldir parts only once.

;now you should have a complete data block containing metadata, the block ends with "CLOSED".
shrink_data	xor	a
		ld	hl,basic_end
shrink_loop	push	hl			;HL=pointer to IPD metadata
		add	a,l
		ld	l,a
		jr	nc,sl2
		inc	h		
sl2		ld	bc,7
		ld	de,ipd2
		call	look_for_string		;stacilo by udelat HL+7 a dat to do DE, ale zatim to nechame
		ld	bc,23
		jp	nz,error		;if next IPD not found, that is a strange error but have to be
						;reported
		call	ConvRStr16
		inc	de			;DE points to valid data block, HL=length of data

		ld	b,h
		ld	c,l
		ld	h,d
		ld	l,e
		pop	de
		ld	a,l
		sub	e
		push	af			;A=number of shifted bytes
shrink_ldir	ldir				;can be "ldir+nop" or "call ldir_dma"
		nop
		push	de			;DE=address of the next block to check

		dec	hl			;read possible checksum
		ld	a,(hl)
		inc	hl
		ld	(php_xor+1),a

		ld	bc,8			;now check, if data end with CLOSED
		ld	de,closed
		call	look_for_string
		pop	hl			;HL=address of the next block to check
		pop	bc			;B=number of shifted bytes
		ld	a,b
		jr	nz,shrink_loop
		ld	(data_end_adr),hl	;HL points to the first byte after valid data block
		jr	data_clean

	IFDEF kurva
kurva		ld	a,6			;for debugging purposes only
		out	(254),a
		halt
	ENDIF

/*
;how it works? No waiting between CIPSENDs needed (in my case I save every buffer to disk)
;IT IS VITAL THE DATA READ ROUTINE HAVE TO READ FURTHER EVEN THOUG ESP DOES NOT RETURN ANY DATA AT THE MOMENT. IT CAN SLEEP FOR WHILE BUT THEN CONTINUES. SEE ROUTINE 7)


		ld	(move_gap1+1),hl	;HL=last address of read byte					
		ld	bc,9
		or	a
		sbc	hl,bc
		ld	a,(hl)			;A=checkusm send by PHP script
		ld	(php_xor+1),a		;data have to end with CLOSED, otherwise this method of
						;finding xor sum by PHP won't work.

		ld	(data_end_adr),hl	;HL=last byte of data block. But have to be adjusted later.
						;see: move_gap

						;pidej kontrolu nad flagy na vstupu
						;now we need to get rid of all the "+IPDs"
						;inside raw data
		pop	bc			;BC=max length of searched bytes
		pop	hl			;HL=start address of search
another_ipd	ld	de,ipd2
		call	look_for_string
						;HL=start of found string,DE=byte coming
						;after found string
		jr	nz,data_clean		;NZ=IPD string not found, use the block
						;of bytes as it is
						;now, we have to exclude IPD string from data
						;bugfix 0.3, eliminate only +IPDs with numbers
		ld	a,(de)			;test byte on DE
		or	a
		jr	nz,ai1			;true IPD found, remove it
		ex	de,hl
		jr	another_ipd
				
						;end of bugfix 0.3

ai1		call	move_gap

		push	hl			;HL=start of next gap

		ld	de,dvojt
		call	look_for_string
		ld	bc,13
		jp	nz,error
		pop	hl			;HL=start of gap
		call	move_gap		;get rid of number and : after IPD
		jr	another_ipd		;look for another IPD
*/


data_clean2	ld	hl,#5555		;start of data read byte from module
dc2		ld	bc,2
		ld	de,er
		push	hl
		call	look_for_string
		pop	de
		ret
	

data_clean					;data are clean in RX_buf,length="data_len"
		ld	bc,2			;now check, if php returns "NE" or "ER"
		ld	de,ne			;maybe also data len could be checked if
data_clean1	ld	hl,#5555		;it is 2
		call	look_for_string
		jr	nz,dc1			
		ex	de,hl			
		call	dc2
		ld	bc,17
		jp	z,error			;php returned "NE"= not exist
		jr	dc3

dc1		call	data_clean2
		ld	bc,18
		jp	z,error			;php returned "ER"= error

						;DE=start of RX_buf

dc3		bit	5,(ix+0)		;bit 5=carry out parity check 1=YES, 0=NO
		jr	z,no_xor_check
						
						;ver0.24- fast way to find out end of data
/*
		push	de			;DE=data start. Now do xor checksum on downloaded data
		pop	hl			;old way, work but search from data beginning:((=>
		ld	bc,buf_len+20		;=> slow
closed_again	ld	de,closed
		call	look_for_string
		push	bc
		ld	bc,21
		jp	nz,error
		pop	bc
		dec	hl

		push	hl			;check if it is wifi app code (special case)
		ld	a,(hl)
		or	a
		jr	nz,ccc1
		dec	hl
		ld	a,(hl)
		cp	#20
		jr	nz,ccc1
		dec	hl
		ld	a,(hl)
		cp	#3A
		jr	nz,ccc1
		ex	de,hl
		pop	de
		jr	closed_again

ccc1		pop	hl			;last data byte+1 (actually XOR checkusm byte address)
;		ld	e,c			;E=XOR checksum sent by PHP script
;
;		ld	b,h			;count clean data length
;		ld	c,l			;BC=end of cleand data
;		pop	bc			;HL-start of cleaned data
;		ld	bc,RX_buf
*/

		ld	hl,(data_end_adr)
		dec	hl
xor_checksum1	ld	bc,#5555		;start of data
		or	a
		sbc	hl,bc

		
		ld	b,h
		ld	c,l			;BC=length of clean data for xor checksum
;		add	hl,bc			;HL=start of data
;		ld	hl,RX_buf
xor_checksum2	ld	hl,#5555		;start of data

		xor	a			;Busy's routine
slucka		xor	(hl)
		cpi
		jp	pe,slucka
php_xor		cp	#55			;A=XOR checksum counted from freshly downloaded data
		jr	z,xor_checksum_ok

		ld	de,parity_error		;NZ=checksum not same, print info to the user
		ld	hl,(prn_xor_txt)
		ld	(HLKO+1),hl
		call	PRINT
		ld	h,d
		ld	l,e			;print position to HL
;		call	clean_line_def		;not needed anymore

		ld	l,(ix+1)		;increase errror count
		ld	h,0
		inc	hl
		inc	(ix+1)
;		ld	de,TX_buf
		ld	de,rele
		push	de
		call	HL2ASCII
		xor	a
		ld	(de),a
		pop	de
		call	PRINT
		ld	hl,par_err
		ld	a,h
		sub	l
		jp	z,error			;Z=maximum number of parity errors reached, end program
		jp	dwnld_cycle		;error in parity check, try again the same block

prn_xor_txt	dw	#4825			;address of "Parity error:" text

no_xor_check
xor_checksum_ok

;here we decide if to pump another data to disk buffer or if it is full and so it is time to save it

		res	6,(ix+0)		;disk buffer not full, not saved
		ld	hl,(disk_buf_adr+1)
		ld	bc,buf_len
		add	hl,bc
		ld	(disk_buf_adr+1),hl	;start addres of next data block incoming from esp
		add	hl,bc			;now test, if should be the last one
		jr	c,save_portion		;C=disk buffer full (maybe fixed to buf len #8000...)
		ld	de,start
;		ld	de,bios
		or	a
		sbc	hl,de			;NC=disk buffer overflow, full, save it
		jr	z,continue_read
		jr	c,continue_read


save_portion	set	6,(ix+0)		;disk buffer full& will be saved
	IFDEF border_colour
		ld	a,6
		out	(254),a
	ENDIF
		push	ix
		call	save_into_file		;data in RX_buf, save the portion
		pop	ix
	IFDEF border_colour
		xor	a
		out	(254),a
	ENDIF
		ld	hl,basic_end
		ld	(disk_buf_adr+1),hl


continue_read	ld	hl,(block_asci+2)
		ld	(HLKO+1),hl
;		call	clean_line
		ld	hl,(current_block)	;print block number as progress indication
		push	hl
		inc	hl			;block 0 not counted
;		ld	de,TX_buf
		ld	de,rele
		push	de
		call	HL2ASCII
		xor	a
		ld	(de),a
		pop	de
		call	PRINT

;		ld	bc,(current_block)	;end of downlad?
		pop	bc
		ld	hl,(file_blocks)
		or	a
		sbc	hl,bc
		jr	z,dwnl_end		;Z=end of download,close file
		inc	bc			;increase current
		ld	(current_block),bc
		jp	dwnld_cycle



dwnl_end	push	ix
	IFDEF border_colour
		ld	a,6
		out	(254),a
	ENDIF
		bit	6,(ix+0)
		jr	nz,dwnl_end1		;NZ=last portion already saved, skip to close the file
		call	save_into_file		;need to test, when file length= disk buffer length
dwnl_end1	call	save_close
		pop	ix
		jr	allok

current_block	dw	#5555		;current part being worked with from 0 (ie. 0,1..)
file_blocks	dw 	#5555		;send by PC (ie. 0,1,2,3= file has 4 parts)

block_asci	ds	5		;blocks converted to ASCII, (used by progress display)
		db	0






endtest		ld	hl,#4000
		ld	de,RX_buf
		call	PRINT		;print result in receive buffer
allok		ld	bc,0
error
	IFDEF border_colour
		xor	a
		out	(254),a
	ENDIF
stack_pointer	ld	sp,#5555
		exx
		ld	hl,10072
		exx
		ei
		ret		;return to BASIC, for the moment
				;BC=1=send_string_error
				;BC=2=STATUS not returned
				;BC=3=fail to send server connection
				;BC=4=server not connected
				;BC=5=send_string_error
				;BC=6=send command error
				;BC=7=200 OK not found
				;BC=8=Content-Length not found
				;BC=9=2x empty line not found
				;BC=10=received content length not found
				;BC=11=received data not found
				;BC=12=start of data not found
				;BC=13=":" not after IPD
				;BC=14=file size not found
				;BC=15=disk error
				;BC=16=user abort (SPACE pressed)
				;BC=17=file does not exist (PHP returned NE)
				;BC=18=problem with blocks (PHP returned ER)
				;BC=19=file does not exist
				;BC=20=test PHP not sucessfull
				;BC=21=uart speed not set sucesfully (bios not set the speed)
				;BC=22=uart speed not set sucesfully (OK not returned by module)
				;BC=23=IPD tag not found among raw data block
				;BC=24=reading of raw data to buffer failed (retries exceeded)
				;BC=25=file for upload not found
				;BC=26=data not sent
				;BC=27=speed management: AT+UART command not sent
				;BC=28=speed management: AT command not accepted
				;BC=29=speed management: all speeds tested, timeout, fix it in terminal
				;BC=30=speed management:failed, probably Wifi module wrongly set,fix in terminal
;after every command has been carried out, the connectin will close, so with every new command the connection have to be opened again. OUT=HL=length of accepted data

make_cipstart	ld	de,RX_buf		;prepare connection command to RX_buf
		ld	a,34			;like eg. "SSL","test.ilnx.cz",443"
		ld	(de),a
		inc	de
		bit	1,(ix+0)		;is SSL or TCP?
		ld	hl,tcp
		jr	z,sec1			;Z=TCP
		ld	hl,ssl
sec1		ld	bc,3
		ldir
		ld	(de),a
		inc	de
		ld	a,44
		ld	(de),a
		inc	de
		ld	a,34
		ld	(de),a
		inc	de
		ld	hl,host_url
		push	hl
		call	count_com_len
		pop	hl
		ld	b,0
		ld	c,a
		ldir				;eg. "test.ilnx.cz"
		ld	a,34
		ld	(de),a
		inc	de
		ld	a,44
		ld	(de),a
		inc	de
		bit	1,(ix+0)		;is SSL or TCP?
		ld	hl,tcp_port
		ld	bc,2
		jr	z,sec2			;Z=TCP
		ld	hl,ssl_port
		ld	c,3
sec2		ldir
		ld	hl,eol
		ld	bc,3
		ldir				;connection command completed in RX_buf
		ret

cipstart_connect
		ld	hl,cipstart		;connect to ilnx server
		call	send_string		;send "AT+CIPSTART="
		ld	bc,3
		jr	nz,error				;connect to server
		ld	hl,RX_buf		;send it
		call	send_string
		ld	bc,3
		jr	nz,error		

		ld	hl,CONNECT
		call	look_on_fly
		ld	bc,4
		jr	nz,error
		jp	clear_rece_buf		;clear the incoming "OK"


make_http_request
		ld	hl,get_php		;form the complete http reqest
		ld	de,TX_buf
		push	de
		ld	bc,5
		ldir				;"GET /"

		ld	hl,RX_buf		;HL=command to send (previously put to RX_buf)
		push	hl
		call	count_com_len
		pop	hl			;HL=command to send
		ld	b,0
		ld	c,a
		ldir				;eg. "download_par.php/...path if any.../?f=img.scr&p=1"

		ld	hl,http11
		ld	bc,11
		ldir				;"HTTP/1.1",#D,#A

		ld	hl,host
		ld	bc,6
		ldir				;"Host: "

		ld	hl,host_url
		push	hl
		call	count_com_len
		pop	hl
		ld	b,0
		ld	c,a
		ldir				;eg. "test.ilnx.cz"

		ex	de,hl
		ld	(hl),#D
		inc	hl
		ld	(hl),#A
		inc	hl
		ex	de,hl

		bit	1,(ix+3)
		jr	z,mhr1

		ld	hl,content_length	;add Content-Length for upload
		push	hl
		call	count_com_len
		pop	hl
		ld	b,0
		ld	c,a
		ldir

		push	de			;add length of file in ASCII
		ld	hl,blen
		ld	de,zzbin
		ld	bc,4
		ldir
		pop	de
		call	HL2ASCII32
		ld	hl,zzdec
		ld	bc,10
		ldir

		ex	de,hl
		ld	(hl),#D
		inc	hl
		ld	(hl),#A
		inc	hl
		ex	de,hl


mhr1		ld	hl,user_agent
		ld	bc,32+13+21
		ldir				;"User-Agent:"... rest of the request
		
		ex	de,hl
		inc	hl
		ld	(hl),c			;0 to signal string end, http request complete in TX buffer
	
		pop	hl		;HL=TX_buf
		call	count_com_len
		ld	h,0		;A=length of command
		ld	l,a
		ld	de,request_len	
		call	HL2ASCII
		xor	a
		ld	(de),a
		ret
request_len	db	#55,#55,#55,#55
rele		db	#55,#55,#55,#55,#55,#55


cipsend_request	ld	hl,cipsend	;now, send the http_request from TX_buf
		call	send_string
		jr	nz,sem

		ld	hl,request_len
		call	send_string	;send length of command

		ld	hl,eol
		call	send_string	;enter the command

		ld	hl,char_zob	;now, await ">"character
		call	look_on_fly
		jr	nz,sem1

		ld	hl,TX_buf	;command in HL=TX_buf address
		call	send_string	;now, send the request itself
		jr	nz,sem3
		

look_sendok	ld	hl,sendok
		call	look_on_fly
		ld	bc,6
		jp	nz,error
		jr	evaluate_answer


sem		ld	a,1
pica		out	(254),a
		ret
sem1		ld	a,2
		jr	pica
sem3		ld	a,3
		jr	pica

;PHP retrieval command sent
;now wait for the answer and parse it
;look for "200 OK" and "IPD+".


evaluate_answer	
look_200OK	ld	hl,_200OK		;because variou servers return various http header
		call	look_on_fly		;we will check "200 OK" only and look for several
		ld	bc,7			;#D,#A sequence. Then body will be caught in RX_buf
		jp	nz,error		;omit seek for COntent-length. Not supported by all servers




	
sec5		bit	2,(ix+0)
		ret	nz			;NZ=http request was "download.php"
						;RX_buf=length of data in ASCII
						;HL=length of data

		ld	hl,_2xEOL
		call	look_on_fly
		ld	bc,9
		jp	nz,error

		ld	bc,buf_len
		ld	hl,RX_buf		;now come the awaited data/body, accept it
		call	receive_data_timeout
						;HL=length of incoming data
		ret				;Z=all OK, received data (body) in RX buffer


/*
;33) "upload_php?f=pic.scr" a do Content-Length musi prijit delka souboru
upload		res	2,(ix+3)		;signal, that loading may continue		
		push	ix
		call	load_init		;prepare file for loading, if file not exist, program terminates
		pop	ix

		ld	hl,upload
		call	prepare_php_com
		call	insert_path
		xor	a
		ld	(de),a			;"upload.php?f=img.scr" prepared in RX_buf (path will be added later)
		res	2,(ix+0)

		call	complete_send
;		call	send_execute_command	;result in RX buffer

;now, load data buffer with the file, and send byte by byte


upload_loop	push	ix
		call	load_file		;load the (part of) file into buffer
		pop	ix

		ld	hl,basic_end
		ld	bc,buf_len
		call	send_data
		ld	bc,26
		jp	nz,error

		bit	2,(ix+3)
		jr	z,upload_loop

		jp	all_ok		




*/
;****************************************************************
;****************************************************************
;****************************************************************


;PARSING
;look for a string in received bytes string, for receive string evaluation purposes
;IN=HL start of the memory area, DE=start of the string we look for, must end with 0, BC=max.len of searched memory, OUT=Z=found, HL=start address of found string in memory, DE=byte coming after found string, NZ=string not found
;10)
look_for_string	ld (lfs5+1),sp
		set 0,(ix+0)

lfs3		ld a,(de)
		cp (hl)
		jr z,lfs_match

		bit 0,(ix+0)		;NZ=no match, was already matching?
		inc hl			;new
		jr nz,lfs2
		dec hl			;new
		pop de			;Z=was matching, now not anymore, renew looked for string
		pop de			;DE=start of searched string
		inc bc
lfs2		set 0,(ix+0)
;		inc hl			;new


lfs1		dec bc
		ld a,b
		or c
		jr nz,lfs3
		inc c			;BC max length reached, set NZ & return
		jr lfs5	

		



lfs_match	bit 0,(ix+0)
		jr z,lfs_alrea_match
		res 0,(ix+0)		;Z=match found, push address
		push de
		push hl

lfs_alrea_match	inc hl
		inc de
		ld a,(de)
		or a
		jr nz,lfs1		;continue macthing if string continues

		ld d,h
		ld e,l			;DE=byte coming after found string
		pop hl			;HL=start address of found string in memory

lfs4		bit 0,(ix+0)
lfs5		ld sp,#5555
		ret			;Z/NZ






;IN=HL=start of looked for string, must end with 0
;OUT=Z=string found, NZ=string not found
;11)
look_on_fly	exx
		ld	bc,0
		exx
		ld	e,#FF		;e= flag, Z=found,NZ=not found
		ld	b,e
		ld	c,e		;BC=timeout
lof3		push	hl
lof1		dec	bc		;bugfix 0.3
lof5		scf
		call	rece_byte
		jr	nz,lof4

		exx			;Z= no byte to receive. ESP can just breathe out and then continue
		dec	bc
		ld	a,c
		or	b
		exx
		jr	z,lofend	;Z=really, no byte to collect
		jr	lof5

lof4		cp	(hl)
		ld	e,0
		jr	z,lof2		

		dec	e		;NZ,char does not match, bring another byte
		pop	hl
		ld	a,b		;max of 65535 unsucessfull tries
		or	c
		jr	z,lofend1
		jr	lof3		

lof2		inc	hl
		ld	a,(hl)
		or	a
		jr	nz,lof1		;still not end, continue search
		
		
lofend		pop	hl
lofend1		inc	e
		dec	e
		ret			;Z/NZ




;RECEIVING
;IN=BC=max.length of data to receive, HL=start of received data, OUT=Z= desired length of data received,opravit vystupni flagy Z/NZ nyn neureny
;6) replaced by reliable routine 7)
	IFUSED receive_data
receive_data	ld a,b
		or c
		ret z			;Z=length reached, return
		scf
		call rece_byte
		ret z			;Z=no byte to receive
		ld (hl),a
		inc hl
		dec bc
		jr receive_data
	ENDIF

;7)
receive_data_timeout
		ld de,#290		;timeout, if #80, only app. first #500 bytes carried correctly
receive_data1	ld a,b			;bios1.2, timeout have to increase to #200
		or c
		ret z			;Z=length reached, return
		scf
		call rece_byte
		jr nz,rd1
		dec de			;Z=no byte to receive
		ld a,e			;DE=timeout, in case there is receive interuption
		or d
		ret z
		jr receive_data1	;do not decrease BC, as no data came in

rd1		ld (hl),a
		inc hl
		dec bc
		jr receive_data1



;SENDING
;IN=HL string (ends with 0), OUT=Z=string has been sent
;1)
send_string	push hl			;print it first
		ld d,h
		ld e,l
		call PRINT
		pop hl

ss2		ld a,(hl)
		or a
		ret z			;Z=end of string

ss1		scf
		call send_byte
		jr nc,ss3
		push af
		ld a,3
		out (254),a		;magenta border= TX line is busy.....
		pop af			;maybe some timeout could be added here
		jr ss1

ss3		inc hl
		xor a
		out (254),a
		jr ss2


;IN=HL start of data, BC=data len, OUT=Z=data has been sent
;2)
send_data	ld a,b
		or c
		ret z			;Z=len of data in BC sent
		ld a,(hl)
		or a
		ret z
sd1		scf
;		ld e,a
		call send_byte
;		ld a,e
		jr c,sd1
		inc hl
		dec bc
		jr send_data

;OTHER
;15)
;IN=HL=command, out=A=len of command
count_com_len	ld b,0			;counts command length
cc1		ld	a,(hl)
		or	a
		ld	a,b
		ret	z
		inc	hl
		inc	b
		jr	cc1

	IFUSED ConvRStr16
;16)
ConvRStr16
;===============================================================
;http://z80-heaven.wikidot.com/math#toc32
;Input: 
;     DE points to the base 10 number string in RAM. 
;Outputs: 
;     HL is the 16-bit value of the number 
;     DE points to the byte after the number 
;     BC is HL/10 
;     z flag reset (nz)
;     c flag reset (nc)
;Destroys: 
;     A (actually, add 30h and you get the ending token) 
;Size:  23 bytes 
;Speed: 104n+42+11c
;       n is the number of digits 
;       c is at most n-2 
;       at most 595 cycles for any 16-bit decimal value 
;===============================================================

     ld hl,0          ;  10 : 210000 
ConvLoop:             ; 
     ld a,(de)        ;   7 : 1A 
     sub 30h          ;   7 : D630 
     cp 10            ;   7 : FE0A 
     ret nc           ;5|11 : D0 
     inc de           ;   6 : 13 
                      ; 
     ld b,h           ;   4 : 44 
     ld c,l           ;   4 : 4D 
     add hl,hl        ;  11 : 29 
     add hl,hl        ;  11 : 29 
     add hl,bc        ;  11 : 09 
     add hl,hl        ;  11 : 29 
                      ; 
     add a,l          ;   4 : 85 
     ld l,a           ;   4 : 6F 
     jr nc,ConvLoop   ;12|23: 30EE 
     inc h            ; --- : 24 			
     jr ConvLoop      ; --- : 18EB
	ENDIF
;17)
;IN=HL=number, OUT=DE=address with the string
HL2ASCII		res 7,(IX+0)		;Leading zero suppression
HL2ASCII_00000		ld bc,10000
			call string_dl
			ld bc,1000
			call string_dl
			ld bc,100
			call string_dl
			ld bc,10
			call string_dl
			ld a,l
			add a,'0'
			LD (DE),A
			INC DE
			RET
			
string_dl:		ld a,'0'-1

string_lp2:		inc a
			or a
			sbc hl,bc
			jr nc,string_lp2
			add hl,bc
			CP '0'
			JR Z,string_store

			SET 7,(IX+0)		;Had something other than zero

string_store:		BIT 7,(IX+0)		;Test if still leading zeros
			RET Z						
			LD (DE),A		;If not store it	
			INC DE
			RET	


;18)
wait_long	ld	b,3		;wait long time, DE delay fixed (3x 65536 times)
wait_long_def	call	wait_short	;wait long time, DE delay suer defined (Bx 65536 times), IN=B=delay
		djnz	wait_long_def
		ret

wait_short	ld	de,0		;wait short time, DE delay fixed (65536 times) (tady by mela stacit polovicni hodnota tedy #8000)!!!!
wait_short_def	dec	de		;wait short time, DE delay user defined,IN=DE=delay
		ld	a,d
		or	e
		jr	nz,wait_short_def
		ret


;19)OUT=prepared php command with parameters in RX_buf, ended with 0
prepare_php_com	push	hl
		call	count_com_len
		pop	hl
		ld	b,0
		ld	c,a
		ld	de,RX_buf
		ldir
		xor	a
		ld	(de),a
		ret


	IFUSED move_gap
;20)
move_gap	ex	de,hl			;moves gap in data block
		push	de
		push	hl
move_gap1	ld	hl,#5555		;last read byte from the module
		or	a
		sbc	hl,de
		push	hl
		pop	bc
		pop	hl
		pop	de			;hl=start after gap,de=start of gap

		push	bc
		push	de

		push	hl			;this part counts shortened bytes
		push	de			;in total it gives data end address after shrinking them
		or	a			;
		sbc	hl,de			;
		ex	de,hl			;
		ld	hl,(data_end_adr)	;
		or	a			;
		sbc	hl,de			;
		ld	(data_end_adr),hl	;	
		pop	de			;
		pop	hl			;end of count_end_data_add part

mv_gap_ldir	ldir				;gap deleted
		nop				;either ldir or dma_ldir

		pop	hl			;hl,bc=input params for another "look_for_str"
		pop	bc
		ret
	ENDIF

;21)
cls		ld	hl,16384
		ld	de,16385
		ld	bc,2047
		ld	(hl),0
		ldir
		ret


;22) by Busy
ConvRStr32

;; Vstup: BC = zaciatok postupnosti cislic ukoncena znakom inym ako cislica
;; Vystup: DEHL = 32 bitova hodnota

	xor	a
	ld	h,a
	ld	l,a
	exx
	ld	h,a
	ld	l,a
	ld	b,a
	ld	c,a
	exx
d32lop	ld	a,(bc)
	sub	'0'
	cp	10
	jr	c,d32ano
	ex	de,hl
	exx
	push	hl
	exx
	pop	hl
	ret

d32ano	ld	d,h
	ld	e,l
	add	hl,hl
	exx
	ld	d,h
	ld	e,l
	adc	hl,hl
	exx
	add	hl,hl
	exx
	adc	hl,hl
	exx
	add	hl,de
	exx
	adc	hl,de
	exx
	add	hl,hl
	exx
	adc	hl,hl
	exx
	ld	e,a
	ld	d,#00
	add	hl,de
	exx
	adc	hl,bc
	exx
	inc	bc
	jr	d32lop

;; Koniec rutinky


	IFUSED clean_line
;23)
clean_line	ld	hl,(block_asci)
clean_line_def	ld	b,3
cl2		push	bc			;clean 5 chars on screen
		push	hl
		ld	b,8
cl1		ld	(hl),0
		call	DOWNHL
		djnz	cl1
		pop	hl
		inc	hl
		pop	bc
		djnz	cl2
		ret
	ENDIF

;24) OUT=Z=path not inserted, NZ=path inserted
insert_path	ld	hl,path
		ld	a,(hl)
		or	a
		jr	z,insert_name		;Z=path not set

			
		push	hl			;insert string with path. Eg. "dir1/dir2/..name.."
		call	count_com_len		;include path to the request
		pop	hl
		ld	b,0
		ld	c,a
		ldir
		dec	de
		ld	a,(de)
		inc	de
		cp	"/"
		jr	z,insert_name
		ld	a,"/"			;add "/" if not input from the user
		ld	(de),a
		inc	de

insert_name	ld	hl,name_php		;add file name
		push	hl
		call	count_com_len
		pop	hl
		ld	b,0
		ld	c,a
		ldir
		inc c
		ret				;path inserted=NZ including file name

	IFUSED count_end_data_add
;25)
count_end_data_add
		push	hl
		push	de
		or	a
		sbc	hl,de
		ex	de,hl
		ld	hl,(data_end_adr)
		or	a
		sbc	hl,de
		ld	(data_end_adr),hl
		pop	de
		pop	hl
		ret
	ENDIF

;26)
ldir_dma
	 ld   (DMAS),hl   ;LDIR pomoci DMAcka - zapise do DMA sekvence zdrojovou adresu
         dec  bc   ;v BC je delka bloku ktera musi byt u DMA snizena o 1 !!! 
         ld   (DMAL),bc   ;opravenou delku bloku zapiseme do DMA sekvence
         ld   (DMAD),de   ;no a tady klasicky ulozime cilovou adresu prenaseneho bloku dat
         exx   
         ld   hl,DMA      ;zacatek DMA sekvence
         ld   bc,LDMA*256+11 ;registr B = delka DMA sekvence, registr C = port DMA
         otir             ;prenos cele DMA sekvence do Z80 DMA(po poslednim odeslanem OUTu se provede DMA prenos)
         exx   
;nasledujici kod uz nema s DMA nic spolecneho
         inc  bc          ;po DMA prenosu vratime delku bloku na spravnou hodnotu 
         add  hl,bc       ;DMA pri prenosu nemeni registry jako u LDIR, takze si
         ex   de,hl       ;pekne registry HL,DE a BC nastavime jako by se provedl LDIR
         add  hl,bc 
         ex   de,hl 
         ld   bc,0 
         ret              ;tohle netusim co dela, musim si procist instrukcni sadu 6502

;----------------------------------------------------

DMA      db %11000011   ;resetuje DMA a nastavi rychlost prenosu portu A a B na 3T
;        db %11000111   ;reset casovani portu A - zbytecne, to dela uz RESET
;        db %11001011   ;reset casovani portu B - zbytecne, to dela uz RESET
         db %01111101   ;DMA rezim=transfer,smer prenosu z port A do B
DMAS     defw 0         ;sem se uklada adresa portu A (odkud se prenasi data)
DMAL     defw 0         ;sem se uklada delka prenaseneho bloku
         db %00010100   ;adresa portu A se pri DMA prenosu inkrementuje,port A je MEMORY
         db %00010000   ;adresa portu B se pri DMA prenosu inkrementuje,port B je MEMORY
;        $C0  !!!! - tady to je stara znama chyba,tento byte je tu uplne na <|> = odstranit
         db %10101101   ;continuous DMA mode
DMAD     defw 0         ;sem se uklada adresa portu B (kam se prenasi data)
         db %10010010   ;stop DMA na konci prenosu,akceptuj WAIT kvuli +2A/+3/Kompakt/M
;nasledujici sekvence tri bajtu spusti DMA prenos (neni treba nastavovat pokazde znovu cele DMA)
         db $CF         ;nastavi interni registry DMA podle predchoziho nastaveni
         db $B3         ;FORCE READY
         db $87         ;ENABLE DMA - spusti DMA prenos

LDMA     equ  $-DMA     ;dma sekvence je ted o 3 bajty kratsi, protoze byl odstranen byte $C0 a resetovani portu A a B
 
;27)
complete_send
		call	make_http_request
		call	make_cipstart
		call	cipstart_connect
		jp	cipsend_request		;send it
		

;28) (Busy's routine)
HL2ASCII32
;Prevod bin->dec bez znamienka
; in: bin
;out: dec

bindec	ld	hl,zzdec            ;; Vynulovanie buffera dec
	ld	bc,lldec*#0100
cls1	ld	(hl),c
	inc	hl
	djnz	cls1
	ld	c,8*llbin           ;; Opakuj pre kazdy bit bin:
bndc0	call	binx2               ;; vyrotovanie bitu z bin
	ld	hl,eedec
	ld	b,lldec             ;; a zarotovanie toho bitu do dec
bndc2	dec	hl
	ld	a,(hl)
	adc	a,a
	cp	#0a
	jr	c,bndc3
	sub	#0a
bndc3	ld	(hl),a
	ccf
	djnz	bndc2
	dec	c
	jr	nz,bndc0
	ret

binx2	ld	hl,zzbin            ;; Nasobenie bin dvomi
	ld	b,llbin
	xor	a
bnxx2	rl	(hl)
	inc	hl
	djnz	bnxx2
	ret

zzbin	db	#ff,#ff,#ff,#ff		;vstup v bajtech
eebin
llbin	=	eebin-zzbin

zzdec	db	0,0,0,0,0		;vystup v ASCII
	db	6,5,5,3,5
eedec
lldec	=	eedec-zzdec

;29)
send_at_check_ok
		ld	hl,at
		call	send_string
		ld	bc,28
		jp	nz,error
;		ld	de,#100			;when it is away, it speeds up the search significantly
;		call	wait_short_def
		ld	hl,RX_buf
		ld	bc,20
		push	hl
		push	bc
		ld	de,RX_buf+1		;clear RX_buf before reading bytes to it
		ld	(hl),0
		ldir
		pop	bc
		pop	hl
		push	hl
		push	bc
		call	receive_data_timeout	;much quicker than look_on_fly
		pop	bc
		pop	hl
		ld	de,ok
		jp	look_for_string


;40) OUT CY 0=OK, 1= speed not supported
set_print_speed	scf
print_speed	call	set_baud
		push	af
		ld	a,d
ps2		ld	de,TX_buf
		push	de
		ld	h,0
		ld	l,a
		call	HL2ASCII
		ld	a,32
		ld	(de),a
		inc	de
		ld	(de),a
		xor	a
		inc	de
		ld	(de),a
		pop	de
		ld	hl,(HLKO+1)
		push	hl
		ld	hl,speed_pos+6
		ld	(HLKO+1),hl
		call	PRINT
		pop	hl			;return print position
		ld	(HLKO+1),hl
		pop	af			;CY/NC
		ret



;commands
at		db "AT",#D,#A,0
ate0		db "ATE0",#D,#A,0
cipmux		db "AT+CIPMUX=",0
cipstatus	db "AT+CIPSTATUS",#D,#A,0
cipstart	db "AT+CIPSTART=",0
cipsend		db "AT+CIPSEND=",0
uart		db "AT+UART_CUR="
_1152000	db "1152000"
_3456000	db "3456000"	
_8100		db ",8,1,0,0",#D,#A


;answers
STATUS		db "STATUS:",0
answ_5		db "5",0
CONNECT		db "CONNECT",0
sendok		db "SEND "
ok		db "OK"
eol		db #D,#A,0
sz		db "SZ: ",0
;ipd		db "+IPD,",0		;"+IPD,8:"nasleduje 8 bajtu dat
ipd2		db #D,#A,"+IPD,",0
dvojt		db ":",0
_2xEOL		db #D,#A,#D,#A,0
char_zob	db "OK",13,10,"> ",0
_200OK		db "200 OK",0
content_len	db "Content-Length: ",0
ne		db "NE",0		;answer from php script in case of error
er		db "ER",0		;answer from php script in case of error
php_ok		db "PHP OK",0
file_size	db "File size: ",0
parity_error	db "Parity errors: ",0	;important, to recognise between app code and "CLOSED" buffer
closed		db "CLOSED",#D,#A,0	;have to be together
apeq		db "&p=",0
got_ip		db "GOT IP",13,10,0

;texts
turnon		db "Turning Wifi ON...",0
wifi		db "Wifi ",0
connected	db "connected ",0
not_txt		db "not ",0
to_AP		db "to AP.",0
wifi_no_success	db "not successful",0
already_on	db "already ON",0
ssl		db "SSL",0
ssl_port	db "443",0
tcp		db "TCP",0
tcp_port	db "80",0
speed		db "Speed:",0


t_php		db "test.php",0
info_php	db "info.php?f=",0
;downl_php	db "download_par.php?f=",0		;X=block number (0,1,2,3....)
downl_php	db "download_sar.php?f=",0		;sar, script returns 32 KB
upload_php	db "upload_php?f=",0

;http request sequence
get_php		db "GET /"					;length=5
http11		db " HTTP/1.1",#D,#A				;length=11
host		db "Host: "					;length=6
content_length	db "Content-Length: "				;length=16	;used only for upload
user_agent	db "User-Agent: ZX Spectrum, MB03+",#D,#A	;length=32
accept		db "Accept: */*",#D,#A				;length=13
connection	db "Connection: close",#D,#A,#D,#A		;length=21
		ds 10
;flags=IX+0
flag1		db 8		;see start of the code, 2=SSL connection,0=TCP
par_err		db #55		;IX+1= parity error counter
		db #FF		;IX+2= maximum number of parity errors
flag2		db 0		;IX+3, see start of the code
		db #20		;IX+4, maximum number of raw data reread, see "rece_loop"
		db 0		;IX+5, starting speed for bios
		db #55		;IX+6, timeout for initi wifi speed management (used on more places)
		db #55		;IX+7, uart speed currently set in HW
		db #55		;IX+8, maximum speed for bios (counted from FW)
;end of flags

core		db #55,#55,#55	

data_end_adr	dw #55		;last address of data block
data_len	dw #55			;length of incoming data
RX_buf		ds #80			;(was #200, in pratice there is 30 bytes) receive buffer,both buffers only for temp communication
TX_buf		ds #FF			;(was #200, in practise, there is 130 bytes) send buffer

	include "keyboard_and_print.asm"
	include "disk_operations.asm"
